# 什么值得买

> 2020.1.11 QuanX 在`190`版本开始, 获取 Cookie 方式需要从`script-response-body`改为`script-request-header`

# 注意！注意！注意！

目前不完美:

1. ~~签到后系统提示“签到结果: 未知”~~ (Fixed)
2. 签到后手机 APP 上显示未签到（但实际上你用 pc 浏览器登录是会显示已经签到的）

上述问题待跟进

## 配置

```properties
[MITM]
*.smzdm.com

[rewrite_local]
# 189及以前版本
^https:\/\/www\.smzdm\.com\/?.? url script-response-body smzdm.cookie.js
# 190及以后版本
^https:\/\/www\.smzdm\.com\/?.? url script-request-header smzdm.cookie.js

[task_local]
1 0 * * * smzdm.js
```

## 说明

1. 先把`*.smzdm.com`加到`[MITM]`
2. 把`smzdm.cookie.js`和`smzdm.js`传到`On My iPhone - Quantumult X - Scripts` (传到 iCloud 相同目录也可, 注意要打开 quanx 的 iCloud 开关)
3. 再把两条脚本分别放到`[rewrite_local]`和`[task_local]`
4. 浏览器访问并登录: https://zhiyou.smzdm.com/user/login
5. 打开浏览器访问: https://www.smzdm.com
6. `QuanX`提示: `Cookie [什么值得买] 写入成功`
7. 最后就可以把`[rewrite_local]`的脚本注释掉了

> 第 1 条脚本是用来获取 cookie 的, 用浏览器访问一次获取 cookie 成功后就可以删掉或注释掉了, 但请确保在`登录成功`后再获取 cookie.

> 第 2 条脚本是签到脚本, 每天`00:01:00`执行一次.

## 常见问题

1. 无法写入 Cookie

   - 检查 QuanX 系统通知权限放开了没
   - 如果你用的是 Safari, 请尝试在浏览地址栏`手动输入网址`(不要用复制粘贴)

2. 写入 Cookie 成功, 但签到不成功

   - 看看是不是在登录前就写入 Cookie 了
   - 如果是，请确保在登录成功后，再尝试写入 Cookie

3. 为什么有时成功有时失败

   - 很正常，网络问题，哪怕你是手工签到也可能失败（凌晨签到容易拥堵就容易失败）
   - 暂时不考虑代码级的重试机制，但咱有配置级的（暴力美学）：

   - `Surge`配置:

     ```properties
     # 没有什么是一顿饭解决不了的:
     cron "10 0 0 * * *" script-path=xxx.js # 每天00:00:10执行一次
     # 如果有，那就两顿:
     cron "20 0 0 * * *" script-path=xxx.js # 每天00:00:20执行一次
     # 实在不行，三顿也能接受:
     cron "30 0 0 * * *" script-path=xxx.js # 每天00:00:30执行一次

     # 再粗暴点，直接:
     cron "* */60 * * * *" script-path=xxx.js # 每60分执行一次
     ```

   - `QuanX`配置:

     ```properties
     [task_local]
     1 0 * * * xxx.js # 每天00:01执行一次
     2 0 * * * xxx.js # 每天00:02执行一次
     3 0 * * * xxx.js # 每天00:03执行一次

     */60 * * * * xxx.js # 每60分执行一次
     ```

## 感谢

[@NobyDa](https://github.com/NobyDa)

[@lhie1](https://github.com/lhie1)

[@ConnersHua](https://github.com/ConnersHua)
